<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 6.2: Structures and Functions</title>
<link href="sx9a.html" rev=precedes>
<link href="sx9c.html" rel=precedes>
<link href="sx9.html" rev=subdocument>
</head>
<body>
<H2>section 6.2: Structures and Functions</H2>

<p>In this section,
we'll begin playing with structures
more or less as if they were ordinary variables
such as we've been using all along
(which they more or less are).
As we'll see,
we can
declare variables of structure type,
declare functions which accept structures as parameters and return them,
declare pointers to structures,
take the address of a structure
(creating a pointer-to-structure)
with <TT>&amp;</TT>,
and assign structures.
</p><p>Notice that when we declare something as ``a structure type,''
we always have to say <em>which</em> structure type,
usually by using the struct tag.
If we've set up a ``point'' structure as above,
then to declare a variable of this type,
we say
<pre>	struct point thepoint;
</pre>Both
<pre>	struct thepoint;	/* WRONG */
</pre>and
<pre>	point thepoint;		/* WRONG */
</pre>would be errors.
</p><p>The above list of things the language lets us do with structures
lets us keep them and move them around,
but there isn't really anything defined by the language
that we can <em>do</em> with structures.
It's up to us to define any operations on structures,
usually by writing functions.
(The <TT>addpoint</TT> function on page 130 is a good example.
It will make a bit more sense
if you think of it as adding not isolated points,
but rather vectors.

[We can't add Seattle plus Los Angeles,
but we could add
(two miles south, one mile east)
plus
(one mile east, two miles north).])
</p><p>page 131
</p><p>As an aside,
how safe are the <TT>min()</TT> and <TT>max()</TT>
macros defined at the top of page 131,
with respect to the criteria
discussed on pages 15 and 16

of the notes
on section 4.11.2 (page 90 in the text)?
</p><p>The precise meaning of the ``shorthand'' <TT>-&gt;</TT> operator
is that <TT>sp-&gt;m</TT> is,
by definition,
equivalent

to <TT>(*sp).m</TT>,
for any structure pointer <TT>sp</TT>
and member <TT>m</TT> of the pointed-to structure.
</p><hr>
<p>
Read sequentially:
<a href="sx9a.html" rev=precedes>prev</a>
<a href="sx9c.html" rel=precedes>next</a>
<a href="sx9.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
